/*

Test for CryptoAPI 

Author : CARDON de Lichtbuer Rodolphe
Augustus 2006
rodolphe@wol.be

*/


#pragma comment (lib, "crypt32.lib")
//#pragma comment (lib, "cryptui.lib")
//#pragma comment (lib, "advapi32.lib")
//#pragma comment (lib, "kernel32.lib")
//#pragma comment (lib, "Cryptnet.lib")

#include <stdio.h>
//#include <iostream>
#include "windows.h"
#include "wincrypt.h"



int main(int argcount, char* arg){

HCERTSTORE store;
const void* pvPara = (const void*) L"My";

//opencertstore 'My'
store=CertOpenStore(
  CERT_STORE_PROV_SYSTEM,
  0,
  NULL,
  CERT_SYSTEM_STORE_CURRENT_USER,
  pvPara
 );

//displays all the certificates to standard output
//for each certificate displays caracteristics : object...
//for each certificate displays 'extended properties' 

PCCERT_CONTEXT  certificateContext=NULL;
char* name=(char*)malloc(100); 
DWORD sizename=100;

while(certificateContext=CertEnumCertificatesInStore(store, certificateContext)){
sizename=100;

sizename = CertGetNameStringA(
  certificateContext,
  CERT_NAME_FRIENDLY_DISPLAY_TYPE,
  0,
  0,
  name,
  sizename);


printf("\nCertificate name : %s\n",name);
printf("taille du certificat : %d\n", certificateContext->cbCertEncoded);

}



//   Clean up.
if (!CertCloseStore(store,0)) {
    printf("Failed CertCloseStore\n");
    exit(1);
   }


printf("\n***\nend\n***\n");
return 0;


}